> For the complete documentation index, see [llms.txt](https://docs.ox.security/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ox.security/api-documentation/api-reference/api--tags/mutations/add-tags.md).

# addTags

Create new tags in the system with optional metadata.

### Examples

{% tabs %}
{% tab title="GraphQL" %}

```graphql
mutation AddTags($input: AddTagInput!) {
  addTags(input: $input) {
    tags {
      tagId
      name
      displayName
      tagType
      createdBy
      createdAt
      updatedAt
      tagCategory
      deploymentModel
      purpose
      email
    }
    failedTags {
      name
      failedReason
    }
  }
}
```

#### Variables

This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.

```json
{
  "input": {
    "tagsInput": [
      {
        "name": "Custom Tag",
        "displayName": "Custom Tag",
        "tagId": "ox_tag_1"
      }
    ]
  }
}
```

{% endtab %}

{% tab title="cURL" %}

```shell
curl -X POST \
https://api.cloud.ox.security/api/apollo-gateway \
-H 'Content-Type: application/json' \
-H 'Authorization: YOUR_API_TOKEN' \
-d '{
 "query": "mutation AddTags($input: AddTagInput!) { addTags(input: $input) { tags { tagId name displayName tagType createdBy createdAt updatedAt tagCategory deploymentModel purpose email } failedTags { name failedReason } } }",
 "variables": {
    "input": {
      "tagsInput": [
        {
          "name": "Custom Tag",
          "displayName": "Custom Tag",
          "tagId": "ox_tag_1"
        }
      ]
    }
  }
}'
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const query = 'mutation AddTags($input: AddTagInput!) { addTags(input: $input) { tags { tagId name displayName tagType createdBy createdAt updatedAt tagCategory deploymentModel purpose email } failedTags { name failedReason } } }';

fetch("https://api.cloud.ox.security/api/apollo-gateway", {
  method: "POST",
  headers: {
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  body: JSON.stringify({
    query: query,
    // This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    variables: {
      input: {
        tagsInput: [
          {
            name: "Custom Tag",
            displayName: "Custom Tag",
            tagId: "ox_tag_1"
          }
        ]
      }
    }
  })
})
.then(response => response.json())
.then(result => console.log(JSON.stringify(result, null, 2)))
.catch(error => console.error('Error:', error));
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

query = 'mutation AddTags($input: AddTagInput!) { addTags(input: $input) { tags { tagId name displayName tagType createdBy createdAt updatedAt tagCategory deploymentModel purpose email } failedTags { name failedReason } } }'

response = requests.post(
  "https://api.cloud.ox.security/api/apollo-gateway",
  headers={
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  json={
    "query": query,
    # This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    "variables": {
      "input": {
        "tagsInput": [
          {
            "name": "Custom Tag",
            "displayName": "Custom Tag",
            "tagId": "ox_tag_1"
          }
        ]
      }
    }
  }
)

if response.status_code == 200:
    result = response.json()
    print(result)
else:
    print(f"Error: {response.status_code}")
    print(response.text)
```

{% endtab %}
{% endtabs %}

### Arguments

You can use the following argument(s) to customize your `addTags` mutation.

| Argument                                                                                                                                                       | Description                                                        | Supported fields                                                                             |
| -------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------ | -------------------------------------------------------------------------------------------- |
| input [`AddTagInput!`](/api-documentation/api-reference/api--tags/types/inputs/add-tag-input.md) <mark style="color:red;background-color:red;">required</mark> | Input containing array of tags to be created with their properties | tagsInput [`[TagDTO!]!`](/api-documentation/api-reference/api--tags/types/inputs/tag-dto.md) |

### Fields

Return type: [`AddTagRes`](/api-documentation/api-reference/api--tags/types/objects/add-tag-res.md)

You can use the following field(s) to specify what information your `addTags` mutation will return. Please note that some fields may have their own subfields.

| Field                                                                                               | Description                                                | Supported fields                                                                                                                                                                                                                                                                                                                                                                                                              |
| --------------------------------------------------------------------------------------------------- | ---------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| tags [`[TagObject!]!`](/api-documentation/api-reference/api--tags/types/objects/tag-object.md)      | Array of newly created tag objects                         | <p>tagId <code>String!</code><br>name <code>String!</code><br>displayName <code>String!</code><br>tagType <a href="/pages/2B1zWrVYXlsbCjeuCgpR"><code>OxTagType!</code></a><br>createdBy <code>String!</code><br>createdAt <code>DateTime</code><br>updatedAt <code>DateTime</code><br>tagCategory <code>String</code><br>deploymentModel <code>String</code><br>purpose <code>String</code><br>email <code>String</code></p> |
| failedTags [`[FailedTag!]`](/api-documentation/api-reference/api--tags/types/objects/failed-tag.md) | Array of tags that failed to be created along with reasons | <p>name <code>String!</code><br>failedReason <code>String!</code></p>                                                                                                                                                                                                                                                                                                                                                         |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ox.security/api-documentation/api-reference/api--tags/mutations/add-tags.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
